Liferay.Loader.define("dynamic-data-mapping-form-builder@3.0.77/js/util/i18n.es", ['module', 'exports', 'require', './strings.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.setLocalizedValue = exports.setValue = void 0;

    var _strings = require("./strings.es");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var setValue = function setValue(obj, languageId, prop, val) {
      if (!obj[prop]) {
        obj[prop] = {};
      }

      obj[prop][languageId] = val;
      return obj;
    };

    exports.setValue = setValue;

    var setLocalizedValue = function setLocalizedValue(obj, languageId, prop, val) {
      obj[prop] = val;
      var localizedProperty = "localized".concat((0, _strings.capitalize)(prop));
      return setValue(obj, languageId, localizedProperty, val);
    };

    exports.setLocalizedValue = setLocalizedValue;
    //# sourceMappingURL=i18n.es.js.map
  }
});
//# sourceMappingURL=i18n.es.js.map