Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.95/FieldBase/FieldBase.es", ['module', 'exports', 'require', '../components/Tooltip/Tooltip.es', 'frontend-taglib-clay$clay-icon', 'dynamic-data-mapping-form-renderer', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', '../util/withDispatch.es', './FieldBase.soy', './withLocale.es', './withRepetitionControls.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    require("../components/Tooltip/Tooltip.es");

    require("frontend-taglib-clay$clay-icon");

    var _dynamicDataMappingFormRenderer = require("dynamic-data-mapping-form-renderer");

    var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

    var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

    var _metalState = require("frontend-js-metal-web$metal-state");

    var _withDispatch = _interopRequireDefault(require("../util/withDispatch.es"));

    var _FieldBase = _interopRequireDefault(require("./FieldBase.soy"));

    var _withLocale = _interopRequireDefault(require("./withLocale.es"));

    var _withRepetitionControls = _interopRequireDefault(require("./withRepetitionControls.es"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    var FieldBase = /*#__PURE__*/function (_Component) {
      _inherits(FieldBase, _Component);

      function FieldBase() {
        _classCallCheck(this, FieldBase);

        return _possibleConstructorReturn(this, _getPrototypeOf(FieldBase).apply(this, arguments));
      }

      _createClass(FieldBase, [{
        key: "prepareStateForRender",
        value: function prepareStateForRender(state) {
          var repeatedIndex = (0, _dynamicDataMappingFormRenderer.getRepeatedIndex)(this.name);
          return _objectSpread(_objectSpread({}, state), {}, {
            showRepeatableAddButton: this.repeatable,
            showRepeatableRemoveButton: this.repeatable && repeatedIndex > 0
          });
        }
      }]);

      return FieldBase;
    }(_metalComponent.default);

    FieldBase.STATE = {
      /**
       * @default input
       * @memberof FieldBase
       * @type {?html}
       */
      contentRenderer: _metalState.Config.any(),

      /**
       * @default false
       * @memberof FieldBase
       * @type {?boolean}
       */
      displayErrors: _metalState.Config.bool().value(false),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      id: _metalState.Config.string(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      label: _metalState.Config.string(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      name: _metalState.Config.string(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(bool|undefined)}
       */
      repeatable: _metalState.Config.bool(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(bool|undefined)}
       */
      required: _metalState.Config.bool(),

      /**
       * @default true
       * @memberof FieldBase
       * @type {?(bool|undefined)}
       */
      showLabel: _metalState.Config.bool().value(true),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      spritemap: _metalState.Config.string().required(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      tip: _metalState.Config.string(),

      /**
       * @default undefined
       * @memberof FieldBase
       * @type {?(string|undefined)}
       */
      tooltip: _metalState.Config.string()
    };
    var composed = (0, _dynamicDataMappingFormRenderer.compose)(_withDispatch.default, _withRepetitionControls.default, _withLocale.default)(FieldBase);

    _metalSoy.default.register(composed, _FieldBase.default);

    var _default = composed;
    exports.default = _default;
    //# sourceMappingURL=FieldBase.es.js.map
  }
});
//# sourceMappingURL=FieldBase.es.js.map