Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.95/components/Tooltip/Tooltip.es", ['module', 'exports', 'require', '../FormPortal/FormPortal.es', 'frontend-taglib-clay$clay-icon', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-position', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Tooltip.soy'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    require("../FormPortal/FormPortal.es");

    require("frontend-taglib-clay$clay-icon");

    var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

    var _metalPosition = require("frontend-js-metal-web$metal-position");

    var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

    var _metalState = require("frontend-js-metal-web$metal-state");

    var _Tooltip = _interopRequireDefault(require("./Tooltip.soy"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    var POSITIONS = ['top', 'left', 'right', 'bottom'];

    var Tooltip = /*#__PURE__*/function (_Component) {
      _inherits(Tooltip, _Component);

      function Tooltip() {
        _classCallCheck(this, Tooltip);

        return _possibleConstructorReturn(this, _getPrototypeOf(Tooltip).apply(this, arguments));
      }

      _createClass(Tooltip, [{
        key: "created",
        value: function created() {
          this._handleTooltipHovered = this._handleTooltipHovered.bind(this);
          this._handleTooltipRendered = this._handleTooltipRendered.bind(this);
        }
      }, {
        key: "_handleTooltipHovered",
        value: function _handleTooltipHovered() {
          this.showContent = true;
        }
      }, {
        key: "_handleTooltipLeaved",
        value: function _handleTooltipLeaved() {
          this.showContent = false;
        }
      }, {
        key: "_handleTooltipRendered",
        value: function _handleTooltipRendered() {
          var _this$refs = this.refs,
              tooltipSource = _this$refs.tooltipSource,
              tooltipTarget = _this$refs.tooltipTarget;
          var element = tooltipSource.element;

          var suggestedPosition = _metalPosition.Align.align(element, tooltipTarget, _metalPosition.Align.Right);

          this.position = POSITIONS[suggestedPosition];
        }
      }]);

      return Tooltip;
    }(_metalComponent.default);

    _metalSoy.default.register(Tooltip, _Tooltip.default);

    Tooltip.STATE = {
      /**
       * @default undefined
       * @instance
       * @memberof Tooltip
       * @type {?(string|undefined)}
       */
      icon: _metalState.Config.string().required(),

      /**
       * @default undefined
       * @instance
       * @memberof Tooltip
       * @type {?(number|undefined)}
       */
      position: _metalState.Config.string(),

      /**
       * @default undefined
       * @instance
       * @memberof Tooltip
       * @type {?(string|undefined)}
       */
      showContent: _metalState.Config.bool(),

      /**
       * @default undefined
       * @instance
       * @memberof Tooltip
       * @type {?(string|undefined)}
       */
      spritemap: _metalState.Config.string().required(),

      /**
       * @default undefined
       * @instance
       * @memberof Tooltip
       * @type {?(string|undefined)}
       */
      text: _metalState.Config.string().required()
    };
    var _default = Tooltip;
    exports.default = _default;
    //# sourceMappingURL=Tooltip.es.js.map
  }
});
//# sourceMappingURL=Tooltip.es.js.map