Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.59/js/components/PageRenderer/EditablePageHeader.es", ['module', 'exports', 'require', 'frontend-js-react-web', 'frontend-js-react-web$react', '../../actions/eventTypes.es', '../../hooks/useForm.es', '../../hooks/usePage.es', '../../util/visitors.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.PageHeader = void 0;

    var _frontendJsReactWeb = require("frontend-js-react-web");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _eventTypes = require("../../actions/eventTypes.es");

    var _useForm = require("../../hooks/useForm.es");

    var _usePage2 = require("../../hooks/usePage.es");

    var _visitors = require("../../util/visitors.es");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var PageHeader = function PageHeader(_ref) {
      var initialDescription = _ref.description,
          placeholder = _ref.placeholder,
          initialTitle = _ref.title;

      var _useState = (0, _react.useState)(initialDescription),
          _useState2 = _slicedToArray(_useState, 2),
          description = _useState2[0],
          setDescription = _useState2[1];

      var _useState3 = (0, _react.useState)(initialTitle),
          _useState4 = _slicedToArray(_useState3, 2),
          title = _useState4[0],
          setTitle = _useState4[1];

      var dispatch = (0, _useForm.useForm)();

      var _usePage = (0, _usePage2.usePage)(),
          editingLanguageId = _usePage.editingLanguageId,
          pageIndex = _usePage.pageIndex,
          pages = _usePage.pages;

      var prevEditingLanguageId = (0, _frontendJsReactWeb.usePrevious)(editingLanguageId);
      (0, _react.useEffect)(function () {
        setDescription(initialDescription);
        setTitle(initialTitle);
      }, [editingLanguageId, initialDescription, initialTitle, prevEditingLanguageId]);

      var handlePageDescriptionChanged = function handlePageDescriptionChanged(value) {
        var visitor = new _visitors.PagesVisitor(pages);
        dispatch({
          payload: visitor.mapPages(function (page, index) {
            if (index === pageIndex) {
              page = _objectSpread(_objectSpread({}, page), {}, {
                description: value,
                localizedDescription: _objectSpread(_objectSpread({}, page.localizedDescription), {}, _defineProperty({}, editingLanguageId, value))
              });
            }

            return page;
          }),
          type: _eventTypes.EVENT_TYPES.PAGE_UPDATED
        });
      };

      var handlePageTitleChanged = function handlePageTitleChanged(value) {
        var visitor = new _visitors.PagesVisitor(pages);
        dispatch({
          payload: visitor.mapPages(function (page, index) {
            if (index === pageIndex) {
              page = _objectSpread(_objectSpread({}, page), {}, {
                localizedTitle: _objectSpread(_objectSpread({}, page.localizedTitle), {}, _defineProperty({}, editingLanguageId, value)),
                title: value
              });
            }

            return page;
          }),
          type: _eventTypes.EVENT_TYPES.PAGE_UPDATED
        });
      };

      return (/*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("input", {
          className: "form-builder-page-header-title form-control p-0",
          maxLength: "120",
          onChange: function onChange(event) {
            var value = event.target.value;
            setTitle(value);
            handlePageTitleChanged(value);
          },
          placeholder: placeholder,
          value: title
        }), /*#__PURE__*/_react.default.createElement("input", {
          className: "form-builder-page-header-description form-control p-0",
          maxLength: "120",
          onChange: function onChange(event) {
            var value = event.target.value;
            setDescription(value);
            handlePageDescriptionChanged(value);
          },
          placeholder: Liferay.Language.get('add-a-short-description-for-this-page'),
          value: description
        }))
      );
    };

    exports.PageHeader = PageHeader;
    //# sourceMappingURL=EditablePageHeader.es.js.map
  }
});
//# sourceMappingURL=EditablePageHeader.es.js.map