Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.59/js/containers/FormNoop.es", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../components/Pages.es', '../hooks/useForm.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.FormNoop = void 0;

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _Pages = _interopRequireDefault(require("../components/Pages.es"));

    var _useForm = require("../hooks/useForm.es");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    /**
     * It is an implementation of Form no-op, it just renders the
     * layout and propagates any event to the instance `dispatch`.
     */
    var FormNoop = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
      var instance = _ref.instance,
          otherProps = _objectWithoutProperties(_ref, ["instance"]);

      return (/*#__PURE__*/_react.default.createElement(_useForm.FormNoopProvider, {
          onEvent: function onEvent(type, payload) {
            return instance === null || instance === void 0 ? void 0 : instance.context.dispatch(type, payload);
          }
        }, /*#__PURE__*/_react.default.createElement(_Pages.default, _extends({}, otherProps, {
          ref: ref
        })))
      );
    });

    exports.FormNoop = FormNoop;
    FormNoop.displayName = 'FormNoop';
    //# sourceMappingURL=FormNoop.es.js.map
  }
});
//# sourceMappingURL=FormNoop.es.js.map