Liferay.Loader.define("dynamic-data-mapping-form-builder@3.0.77/js/components/FormBuilder/withMultiplePages.es", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-jsx', 'frontend-js-metal-web$metal-state', './props.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _metalJsx = _interopRequireDefault(require("frontend-js-metal-web$metal-jsx"));

    var _metalState = require("frontend-js-metal-web$metal-state");

    var _props = _interopRequireDefault(require("./props.es"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance");
    }

    function _iterableToArray(iter) {
      if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) {
        for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
          arr2[i] = arr[i];
        }return arr2;
      }
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    var withMultiplePages = function withMultiplePages(ChildComponent) {
      var MultiplePages = /*#__PURE__*/function (_Component) {
        _inherits(MultiplePages, _Component);

        function MultiplePages() {
          _classCallCheck(this, MultiplePages);

          return _possibleConstructorReturn(this, _getPrototypeOf(MultiplePages).apply(this, arguments));
        }

        _createClass(MultiplePages, [{
          key: "getPages",
          value: function getPages() {
            var pages = this.props.pages;
            var _this$props = this.props,
                defaultLanguageId = _this$props.defaultLanguageId,
                paginationMode = _this$props.paginationMode,
                successPageSettings = _this$props.successPageSettings;

            if (successPageSettings.enabled) {
              pages = [].concat(_toConsumableArray(pages), [{
                contentRenderer: 'success',
                defaultLanguageId: defaultLanguageId,
                paginationItemRenderer: "".concat(paginationMode, "_success"),
                rows: [],
                successPageSettings: successPageSettings
              }]);
            }

            return pages.map(function (page) {
              return _objectSpread(_objectSpread({}, page), {}, {
                enabled: true
              });
            });
          }
        }, {
          key: "getPaginationPosition",
          value: function getPaginationPosition() {
            var _this$props2 = this.props,
                pages = _this$props2.pages,
                paginationMode = _this$props2.paginationMode;
            var position = paginationMode === 'wizard' ? 'top' : 'bottom';
            return pages.length > 1 ? position : 'top';
          }
        }, {
          key: "render",
          value: function render() {
            IncrementalDOM.elementOpen("div", null, null, "class", "container ddm-paginated-builder ".concat(this.getPaginationPosition()));
            IncrementalDOM.elementOpenStart(ChildComponent);
            iDOMHelpers.forOwn(this.props, iDOMHelpers.attr);
            IncrementalDOM.attr("pages", this.getPages());
            IncrementalDOM.elementOpenEnd(ChildComponent);
            IncrementalDOM.elementClose(ChildComponent);
            return IncrementalDOM.elementClose("div");
          }
        }]);

        return MultiplePages;
      }(_metalJsx.default);

      MultiplePages.PROPS = _objectSpread({
        /**
         * @instance
         * @memberof LayoutProvider
         * @type {boolean}
         */
        allowSuccessPage: _metalState.Config.bool().value(true)
      }, _props.default);
      MultiplePages.STATE = {
        /**
         * @default false
         * @instance
         * @memberof FormRenderer
         * @type {boolean}
         */
        dropdownExpanded: _metalState.Config.bool().value(false).internal()
      };
      return MultiplePages;
    };

    var _default = withMultiplePages;
    exports.default = _default;
    //# sourceMappingURL=withMultiplePages.es.js.map
  }
});
//# sourceMappingURL=withMultiplePages.es.js.map