Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.95/RichText/RichText.es", ['module', 'exports', 'require', 'frontend-editor-ckeditor-web', 'frontend-js-react-web$react', '../FieldBase/ReactFieldBase.es', '../hooks/useSyncValue.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _frontendEditorCkeditorWeb = require("frontend-editor-ckeditor-web");

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _ReactFieldBase = require("../FieldBase/ReactFieldBase.es");

    var _useSyncValue3 = require("../hooks/useSyncValue.es");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    var RichText = function RichText(_ref) {
      var editorConfig = _ref.editorConfig,
          id = _ref.id,
          name = _ref.name,
          onBlur = _ref.onBlur,
          _onChange = _ref.onChange,
          onFocus = _ref.onFocus,
          predefinedValue = _ref.predefinedValue,
          readOnly = _ref.readOnly,
          value = _ref.value,
          visible = _ref.visible,
          otherProps = _objectWithoutProperties(_ref, ["editorConfig", "id", "name", "onBlur", "onChange", "onFocus", "predefinedValue", "readOnly", "value", "visible"]);

      var _useSyncValue = (0, _useSyncValue3.useSyncValue)(value ? value : predefinedValue),
          _useSyncValue2 = _slicedToArray(_useSyncValue, 2),
          currentValue = _useSyncValue2[0],
          setCurrentValue = _useSyncValue2[1];

      return (/*#__PURE__*/_react.default.createElement(_ReactFieldBase.FieldBase, _extends({}, otherProps, {
          id: id,
          name: name,
          readOnly: readOnly,
          style: readOnly ? {
            pointerEvents: 'none'
          } : null,
          visible: visible
        }), /*#__PURE__*/_react.default.createElement(_frontendEditorCkeditorWeb.ClassicEditor, {
          contents: currentValue,
          data: currentValue,
          editorConfig: editorConfig,
          name: name,
          onBlur: onBlur,
          onChange: function onChange(data) {
            if (currentValue !== data) {
              setCurrentValue(data);

              _onChange({}, data);
            }
          },
          onFocus: onFocus,
          readOnly: readOnly
        }), /*#__PURE__*/_react.default.createElement("input", {
          defaultValue: currentValue,
          id: id || name,
          name: name,
          type: "hidden"
        }))
      );
    };

    var _default = RichText;
    exports.default = _default;
    //# sourceMappingURL=RichText.es.js.map
  }
});
//# sourceMappingURL=RichText.es.js.map