Liferay.Loader.define("multi-factor-authentication-timebased-otp-web@1.0.36/qrcode/generateQRCode", ['module', 'exports', 'require', 'multi-factor-authentication-timebased-otp-web$qrcode'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = generateQRCode;

    var _qrcode = _interopRequireDefault(require("multi-factor-authentication-timebased-otp-web$qrcode"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function generateQRCode(containerId, _ref) {
      var account = _ref.account,
          algorithm = _ref.algorithm,
          counter = _ref.counter,
          digits = _ref.digits,
          issuer = _ref.issuer,
          secret = _ref.secret;
      var url = new URL('otpauth://totp/' + encodeURIComponent(account));

      url.search = Object.entries({
        algorithm: algorithm,
        counter: counter,
        digits: digits,
        issuer: issuer,
        secret: secret
      }).map(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        return "".concat(key, "=").concat(encodeURIComponent(value));
      }).join('&');

      _qrcode.default.toDataURL(url.toString()).then(function (dataUrl) {
        var image = document.createElement('img');
        image.setAttribute('src', dataUrl);
        var container = document.getElementById(containerId);
        container.appendChild(image);
      }).catch(function (err) {
        console.error(err);
      });
    }
    //# sourceMappingURL=generateQRCode.js.map
  }
});
//# sourceMappingURL=generateQRCode.js.map